#ifndef LSTM__H
#define LSTM__H

#include <torch/torch.h>
#include "fmt/core.h"

class LSTMImpl : public torch::nn::Module
{
  private :

  torch::nn::LSTM lstm{nullptr};
  bool outputAll;

  public :

  LSTMImpl(int inputSize, int outputSize, std::tuple<bool,bool,int,float,bool> options);
  torch::Tensor forward(torch::Tensor input);
  int getOutputSize(int sequenceLength);
};
TORCH_MODULE(LSTM);

#endif

