#ifndef LSTMNETWORK__H
#define LSTMNETWORK__H

#include "NeuralNetwork.hpp"
#include "LSTM.hpp"

class LSTMNetworkImpl : public NeuralNetworkImpl
{
  private :

  int unknownValueThreshold;
  std::vector<std::string> focusedColumns;
  std::vector<int> maxNbElements;
  int leftWindowRawInput;
  int rightWindowRawInput;
  int rawInputSize;

  torch::nn::Embedding wordEmbeddings{nullptr};
  torch::nn::Dropout embeddingsDropout{nullptr};
  torch::nn::Dropout lstmDropout{nullptr};
  torch::nn::Dropout hiddenDropout{nullptr};
  torch::nn::Linear linear1{nullptr};
  torch::nn::Linear linear2{nullptr};
  LSTM contextLSTM{nullptr};
  LSTM rawInputLSTM{nullptr};
  LSTM splitTransLSTM{nullptr};
  std::vector<LSTM> lstms;

  public :

  LSTMNetworkImpl(int nbOutputs, int unknownValueThreshold, std::vector<int> bufferContext, std::vector<int> stackContext, std::vector<std::string> columns, std::vector<int> focusedBufferIndexes, std::vector<int> focusedStackIndexes, std::vector<std::string> focusedColumns, std::vector<int> maxNbElements, int leftWindowRawInput, int rightWindowRawInput);
  torch::Tensor forward(torch::Tensor input) override;
  std::vector<std::vector<long>> extractContext(Config & config, Dict & dict) const override;
};

#endif
